## ros-humble-control-toolbox 3.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(control_toolbox LANGUAGES CXX)

if(CMAKE_CXX_COMPILER_ID MATCHES "(GNU|Clang)")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(WIN32)
  # Enable Math Constants
  # https://docs.microsoft.com/en-us/cpp/c-runtime-library/math-constants?view=vs-2019
  add_compile_definitions(
    _USE_MATH_DEFINES
  )
endif()

set(THIS_PACKAGE_INCLUDE_DEPENDS
  control_msgs
  rclcpp
  rcutils
  realtime_tools
)

find_package(ament_cmake REQUIRED)
foreach(Dependency IN ITEMS ${THIS_PACKAGE_INCLUDE_DEPENDS})
  find_package(${Dependency} REQUIRED)
endforeach()

add_library(control_toolbox SHARED
  src/dither.cpp
  src/limited_proxy.cpp
  src/pid_ros.cpp
  src/pid.cpp
  src/sine_sweep.cpp
  src/sinusoid.cpp
)
target_compile_features(control_toolbox PUBLIC cxx_std_17)
target_include_directories(control_toolbox PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include/control_toolbox>
)
ament_target_dependencies(control_toolbox PUBLIC ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_compile_definitions(control_toolbox PRIVATE "CONTROL_TOOLBOX_BUILDING_LIBRARY")

if(BUILD_TESTING)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(rclcpp_lifecycle REQUIRED)

  ament_add_gmock(pid_tests test/pid_tests.cpp)
  target_link_libraries(pid_tests control_toolbox)

  ament_add_gtest(pid_parameters_tests test/pid_parameters_tests.cpp)
  target_link_libraries(pid_parameters_tests control_toolbox)

  ament_add_gtest(pid_publisher_tests test/pid_publisher_tests.cpp)
  target_link_libraries(pid_publisher_tests control_toolbox)
  ament_target_dependencies(pid_publisher_tests rclcpp_lifecycle)
endif()

install(
  DIRECTORY include/
  DESTINATION include/control_toolbox
)
install(TARGETS control_toolbox
  EXPORT export_control_toolbox
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

ament_export_targets(export_control_toolbox HAS_LIBRARY_TARGET)
ament_export_dependencies(${THIS_PACKAGE_INCLUDE_DEPENDS})
ament_package()

=== debian/changelog ===
ros-humble-control-toolbox (3.1.0-1jammy) jammy; urgency=high

  * Check for i_min <= i_max at initialization (#139 <https://github.com/ros-controls/control_toolbox/issues/139>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 28 Apr 2023 23:00:00 -0000

ros-humble-control-toolbox (3.0.0-1jammy) jammy; urgency=high

  * [PidROS] Enable interpreting prefix as param prefix. (#129 <https://github.com/ros-controls/control_toolbox/issues/129>)
  * Use std::clamp (#140 <https://github.com/ros-controls/control_toolbox/issues/140>)
  * [CI] Fixes and update for branch out (#155 <https://github.com/ros-controls/control_toolbox/issues/155>)
  * Enable subclassing of PID implementation. (#148 <https://github.com/ros-controls/control_toolbox/issues/148>)
  * [CI] Add Humble job (#147 <https://github.com/ros-controls/control_toolbox/issues/147>)
  * Finally update formatting to other repositories convention. (#131 <https://github.com/ros-controls/control_toolbox/issues/131>)
  * [CI] 🔧 Update pre-commit hooks and sync actions to other repositories. (#130 <https://github.com/ros-controls/control_toolbox/issues/130>)
  * Contributors: Bence Magyar, Christoph Fröhlich, Dr. Denis, dependabot[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 04 Apr 2023 23:00:00 -0000

ros-humble-control-toolbox (2.2.0-1jammy) jammy; urgency=high

  * Fix overriding of package (#145 <https://github.com/ros-controls/control_toolbox/issues/145>)
  * Various dependabot version bumps
  * [CI] Add dependabot configuration to automatically update actions.
  * Contributors: Christoph Fröhlich, Dr. Denis, Tyler Weaver, dependabot[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 20 Feb 2023 00:00:00 -0000

ros-humble-control-toolbox (2.1.2-1jammy) jammy; urgency=high

  * export missing dependency (#128 <https://github.com/ros-controls/control_toolbox/issues/128>)
  * Contributors: Noel Jiménez García

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 15 Nov 2022 00:00:00 -0000

ros-humble-control-toolbox (2.1.1-1jammy) jammy; urgency=high

  * Add declaration of parameters in ROSPid.
  * Fix namespace collision and parameter_callback problems in PidROS
  * Contributors: Aris Synodinos, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 05 Nov 2022 00:00:00 -0000

ros-humble-control-toolbox (2.1.0-1jammy) jammy; urgency=high

  * Fix parameter loading log levels
  * Support pass in a precomputed derivative error
  * Add getParametersCallbackHandle function
  * Add topic_prefix_ to declareParam & setParameter
  * Update include/control_toolbox/dither.hpp
  * Correct contributing and license files for ament_copyright.
  * Added license text file and contributing guidelines, corrected license short identifier.
  * Remove build of downstream workspace.
  * Update CI config and add pre-commit-config.
  * Contributors: Bence Magyar, ChenJun, Denis Štogl, Timon Engelke

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 29 Jun 2022 23:00:00 -0000

ros-humble-control-toolbox (2.0.2-1jammy) jammy; urgency=high

  * remove unused variables
  * Update visibility_control.hpp
  * Windows bringup.
  * Contributors: Karsten Knese, Sean Yen, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 May 2021 23:00:00 -0000

ros-humble-control-toolbox (2.0.1-1jammy) jammy; urgency=high

  * Fix dependencies
  * Export ament_cmake build type
  * Contributors: ahcorde

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 31 Jul 2020 23:00:00 -0000

ros-humble-control-toolbox (2.0.0-1jammy) jammy; urgency=high

  * Refactor the Pid class to be completely ROS agnostic and added a ROS 2 wrapper
  * Avoid crash when the type of the parameter doesn't match
  * Added topic_prefix to publisher topic name (#95 <https://github.com/ros-controls/control_toolbox/issues/95>)
  * Created a shared library (#93 <https://github.com/ros-controls/control_toolbox/issues/93>)
  * Aliases not part of the public API are now private
  * Removing pid_gains_setter
  * Removed unnecessary dependencies
  * Cleared empty non virtual destructors
  * Removed unused limited proxy variables
  * Added pid state real-time publisher
  * Removed all references to tinyxml
  * Removed tune_pid.py
  * Adding missing copyright licenses
  * Adapted dither, sine_sweep and sinusoid to ROS2
  * Removed dynamic reconfigure completely
  * Removed deprecated functions
  * Contributors: Alejandro Hernández Cordero, Bence Magyar, James Xu, Jordan Palacios, Shane Loretz, ahcorde

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 27 Jul 2020 23:00:00 -0000

ros-humble-control-toolbox (1.17.0-1jammy) jammy; urgency=high

  * update anti windup clamping
  * update negativeIntegrationAntiwindupTest
  * Address catkin_lint issues
  * Add executable flag
  * convert to package xml format 2
  * Remove doc header
  * Contributors: Bence Magyar, Cong, Gennaro Raiola

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 31 Jan 2019 00:00:00 -0000

ros-humble-control-toolbox (1.16.0-1jammy) jammy; urgency=high

  * switched to industrial_ci
  * Add control_msgs to CATKIN_DEPENDS.
  * Contributors: Bence Magyar, Mathias Luedtke, Mike Purvis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 30 Nov 2017 00:00:00 -0000

ros-humble-control-toolbox (1.15.0-1jammy) jammy; urgency=high

  * avoid ABI breaks in PID class
  * fix add_dependencies call
  * rollback API changes in PID class
  * cfg: removed rosbuild support related error handling
  * Contributors: Bence Magyar, Igor Napolskikh, ipa-mig

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 27 Jun 2016 23:00:00 -0000

ros-humble-control-toolbox (1.14.0-1jammy) jammy; urgency=high

  * Fix negative gains issue and add tests; update gains setting through DynamicReconfig
  * Add antiwindup and tests to PID controller; rename old behaviour 'clamping'
  * Move message to control_toolbox


=== debian/control ===
Source: ros-humble-control-toolbox
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-ament-cmake-gmock <!nocheck>, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-control-msgs, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle <!nocheck>, ros-humble-rcutils, ros-humble-realtime-tools, ros-humble-ros-workspace
Homepage: http://ros.org/wiki/control_toolbox
Standards-Version: 3.9.2

Package: ros-humble-control-toolbox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-control-msgs, ros-humble-rclcpp, ros-humble-rcutils, ros-humble-realtime-tools, ros-humble-ros-workspace
Description: The control toolbox contains modules that are useful across all controllers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-control-toolbox//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-control-toolbox 3.2.0

=== debian/changelog ===
ros-humble-control-toolbox (3.2.0-1bookworm) bookworm; urgency=high

  * [CI] fix source build (#168 <https://github.com/ros-controls/control_toolbox/issues/168>)
  * Bump actions/setup-python from 4 to 5 (#167 <https://github.com/ros-controls/control_toolbox/issues/167>)
  * [CI] Touchups (#166 <https://github.com/ros-controls/control_toolbox/issues/166>)
  * [PID] Update documentation to reflect ROS 2 usage of time (#165 <https://github.com/ros-controls/control_toolbox/issues/165>)
  * Bump actions/checkout from 3 to 4 (#163 <https://github.com/ros-controls/control_toolbox/issues/163>)
  * Bump ros-tooling/setup-ros from 0.6 to 0.7 (#161 <https://github.com/ros-controls/control_toolbox/issues/161>)
  * Add filters structure and lowpass filter (#152 <https://github.com/ros-controls/control_toolbox/issues/152>)
  * Bump codecov/codecov-action from 3.1.2 to 3.1.4 (#160 <https://github.com/ros-controls/control_toolbox/issues/160>)
  * Contributors: Christoph Fröhlich, GuiHome, Patrick Roncagliolo

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 11 Dec 2023 16:00:00 -0000

ros-humble-control-toolbox (3.1.0-1bookworm) bookworm; urgency=high

  * Check for i_min <= i_max at initialization (#139 <https://github.com/ros-controls/control_toolbox/issues/139>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 28 Apr 2023 16:00:00 -0000

ros-humble-control-toolbox (3.0.0-1bookworm) bookworm; urgency=high

  * [PidROS] Enable interpreting prefix as param prefix. (#129 <https://github.com/ros-controls/control_toolbox/issues/129>)
  * Use std::clamp (#140 <https://github.com/ros-controls/control_toolbox/issues/140>)
  * [CI] Fixes and update for branch out (#155 <https://github.com/ros-controls/control_toolbox/issues/155>)
  * Enable subclassing of PID implementation. (#148 <https://github.com/ros-controls/control_toolbox/issues/148>)
  * [CI] Add Humble job (#147 <https://github.com/ros-controls/control_toolbox/issues/147>)
  * Finally update formatting to other repositories convention. (#131 <https://github.com/ros-controls/control_toolbox/issues/131>)
  * [CI] 🔧 Update pre-commit hooks and sync actions to other repositories. (#130 <https://github.com/ros-controls/control_toolbox/issues/130>)
  * Contributors: Bence Magyar, Christoph Fröhlich, Dr. Denis, dependabot[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 04 Apr 2023 16:00:00 -0000

ros-humble-control-toolbox (2.2.0-1bookworm) bookworm; urgency=high

  * Fix overriding of package (#145 <https://github.com/ros-controls/control_toolbox/issues/145>)
  * Various dependabot version bumps
  * [CI] Add dependabot configuration to automatically update actions.
  * Contributors: Christoph Fröhlich, Dr. Denis, Tyler Weaver, dependabot[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 19 Feb 2023 16:00:00 -0000

ros-humble-control-toolbox (2.1.2-1bookworm) bookworm; urgency=high

  * export missing dependency (#128 <https://github.com/ros-controls/control_toolbox/issues/128>)
  * Contributors: Noel Jiménez García

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 14 Nov 2022 16:00:00 -0000

ros-humble-control-toolbox (2.1.1-1bookworm) bookworm; urgency=high

  * Add declaration of parameters in ROSPid.
  * Fix namespace collision and parameter_callback problems in PidROS
  * Contributors: Aris Synodinos, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 04 Nov 2022 16:00:00 -0000

ros-humble-control-toolbox (2.1.0-1bookworm) bookworm; urgency=high

  * Fix parameter loading log levels
  * Support pass in a precomputed derivative error
  * Add getParametersCallbackHandle function
  * Add topic_prefix_ to declareParam & setParameter
  * Update include/control_toolbox/dither.hpp
  * Correct contributing and license files for ament_copyright.
  * Added license text file and contributing guidelines, corrected license short identifier.
  * Remove build of downstream workspace.
  * Update CI config and add pre-commit-config.
  * Contributors: Bence Magyar, ChenJun, Denis Štogl, Timon Engelke

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 29 Jun 2022 16:00:00 -0000

ros-humble-control-toolbox (2.0.2-1bookworm) bookworm; urgency=high

  * remove unused variables
  * Update visibility_control.hpp
  * Windows bringup.
  * Contributors: Karsten Knese, Sean Yen, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 May 2021 16:00:00 -0000

ros-humble-control-toolbox (2.0.1-1bookworm) bookworm; urgency=high

  * Fix dependencies
  * Export ament_cmake build type
  * Contributors: ahcorde

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 31 Jul 2020 16:00:00 -0000

ros-humble-control-toolbox (2.0.0-1bookworm) bookworm; urgency=high

  * Refactor the Pid class to be completely ROS agnostic and added a ROS 2 wrapper
  * Avoid crash when the type of the parameter doesn't match
  * Added topic_prefix to publisher topic name (#95 <https://github.com/ros-controls/control_toolbox/issues/95>)
  * Created a shared library (#93 <https://github.com/ros-controls/control_toolbox/issues/93>)
  * Aliases not part of the public API are now private
  * Removing pid_gains_setter
  * Removed unnecessary dependencies
  * Cleared empty non virtual destructors
  * Removed unused limited proxy variables
  * Added pid state real-time publisher
  * Removed all references to tinyxml
  * Removed tune_pid.py
  * Adding missing copyright licenses
  * Adapted dither, sine_sweep and sinusoid to ROS2
  * Removed dynamic reconfigure completely
  * Removed deprecated functions
  * Contributors: Alejandro Hernández Cordero, Bence Magyar, James Xu, Jordan Palacios, Shane Loretz, ahcorde

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 27 Jul 2020 16:00:00 -0000

ros-humble-control-toolbox (1.17.0-1bookworm) bookworm; urgency=high

  * update anti windup clamping
  * update negativeIntegrationAntiwindupTest
  * Address catkin_lint issues


=== debian/control ===
Source: ros-humble-control-toolbox
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-ament-cmake-gmock <!nocheck>, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-control-msgs, ros-humble-filters, ros-humble-generate-parameter-library, ros-humble-geometry-msgs, ros-humble-pluginlib, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle <!nocheck>, ros-humble-rcutils, ros-humble-realtime-tools, ros-humble-ros-workspace
Homepage: http://ros.org/wiki/control_toolbox
Standards-Version: 3.9.2

Package: ros-humble-control-toolbox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-control-msgs, ros-humble-filters, ros-humble-generate-parameter-library, ros-humble-geometry-msgs, ros-humble-pluginlib, ros-humble-rclcpp, ros-humble-rcutils, ros-humble-realtime-tools, ros-humble-ros-workspace
Description: The control toolbox contains modules that are useful across all controllers.

=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-control-toolbox//opt/ros/humble/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-control-toolbox//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-control-toolbox//opt/ros/humble/opt/control_toolbox/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
